Subject: __hci_cmd_sync() not suitable for nokia h4p

From: [email-masked] (Pavel Machek)
Date: Fri, 12 Dec 2014 10:51:54 +0100

Hi!

> >>>> What needs to be done is the bring up of the device including the proper UART settings and speed and then just run the firmware downloads. All firmware files on the Nokia devices where just HCI commands with vendor specific details. Some from CSR, some from Broadcom and some from TI. You can actually decode them if you really want to. Shouldn't be that hard.
> >>>> 
> >>> 
> >>> Speed changes at the end of firmware load, but I guess that's detail?
> >>> Anyway, patch would look like this.
> >> 
> >> You should really look into providing hdev->setup() callback. That is normally the callback where you want to load the firmware.
> >> 
> > 
> > I can provide setup() callback and load firmware from there.
> > 
> > I have created provisional device tree binding, and the driver still
> > works.
> > 
> > Some time ago you mentioned that with the "big" issues fixed, you'd be
> > willing to take it into the tree. What way forward do you see? Would
> > it make sense to re-enable the driver in staging, so that "big"
> > changes could be applied, followed by renames?
> 
> If the driver is clean, there is no point in taking it through staging. It can be cleaned up and then merged all together.
>

Ok, so you can revert a4102f90e87cfaa3fdbed6fdf469b23f0eeb4bfd in your
tree, and I can post patches against that?

> I think the important part is to focus on the N900 derivative with
>the Broadcom chip inside. And just ignore all the rest. So start
>small and do not try to carry the N770, N800, N810 hacks over.

Well, I did remove non-relevant firmware loaders, and I can remove the
switches for different firmware loaders, too, but spending time
removing support for different hardware does not sound quite right.

> However you might want to check Neil Brown's patches for TTY-slave
>devices he just posted. Maybe the N900 devices should be exposed as
>TTY and we just attach N_HCI line discipline to it. If all the GPIO
>wiggling can be done automatically at TTY open, then that should be
>the way to go. I also send an email about using the new unconfigured
>stage to get this done cleanly.

I seen them, but they don't help, I'm afraid. The GPIOs are used for
power saving, and they are used in various places including the serial
irq handler.

Best regards,
									Pavel
-- 
(english) http://www.livejournal.com/~pavelmachek
(cesky, pictures) http://atrey.karlin.mff.cuni.cz/~pavel/picture/horses/blog.html